import { AccessMemoryFunc, ClockMode } from "./types";
export declare class CPU6502 {
    instructionsPerEventLoopBreathe: number;
    logInstructions: boolean;
    logInternalState: boolean;
    maxInstructions: undefined | number;
    reg_a: number;
    reg_x: number;
    reg_y: number;
    programCounter: number;
    stackPointer: number;
    processorStatus: number;
    clockMode: ClockMode;
    private interruptPending;
    private isExecuting;
    instructionsExecuted: number;
    accessMemory: AccessMemoryFunc;
    constructor({ accessMemory, logInstructions, maxInstructions, }: {
        accessMemory?: AccessMemoryFunc;
        logInstructions?: boolean;
        maxInstructions?: number;
    });
    reset(): void;
    triggerIRQB(setBrk: boolean): void;
    triggerNMIB(): void;
    startClock(): void;
    pauseClock(): void;
    private executeNextInstruction;
    private ensureExecutingIfNotPaused;
    private execInterruptReset;
    execInterruptIRQB(): void;
    execInterruptNMIB(): void;
    _read8BitValue(address: number): number;
    _write8BitValue(address: number, value: number): void;
    _read16BitValue(address: number): number;
    _write16BitValue(address: number, value: number): void;
    _push8BitValueToStack(value: number): void;
    _pull8BitValueFromStack(): number;
    _push16BitValueToStack(value: number): void;
    _pull16BitValueFromStack(): number;
    _decSP(): void;
    _incSP(): void;
    _convertValueTo8BitAndSetStatusFlags(value: number, checkCarry?: boolean): number;
}
