"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const CPU6502_1 = require("../CPU6502");
const types_1 = require("../types");
const fs = require("fs-extra-promise");
const ramImagePath = __dirname + "/../../programs/a.out";
async function run() {
    // set up memory
    const ramImage = await fs.readFileAsync(ramImagePath);
    // load image from disk
    const ram = Uint8ClampedArray.from(ramImage);
    const accessMemory = (readWrite, address, value) => {
        // capture a write to 0x6000 as a magic output address, print to console
        if (address === 0x6000 && readWrite === types_1.ReadWrite.write) {
            console.log("Output: ", value.toString(16), value.toString(2).padStart(8, "0"));
            return;
        }
        if (address === 0x6005 && readWrite === types_1.ReadWrite.write) {
            console.log("Exit captured! pausing clock");
            cpu.pauseClock();
            return;
        }
        if (readWrite === types_1.ReadWrite.read) {
            return ram[address];
        }
        ram[address] = value;
    };
    // @ts-ignore
    const cpu = new CPU6502_1.CPU6502({
        accessMemory,
        logInstructions: true,
        maxInstructions: 50,
    });
    cpu.reset();
}
run().catch(console.error);
//# sourceMappingURL=3_execute.js.map